from N_INSEE import N_INSEE


class University:
    def __init__(self, *students):
        self.__students = {}  # Python common dictionary...
        for s in students:
            # print(s)
            self.__students[s.get_n_insee()] = s  # Danger: index is based on a *HOMEMADE* built type!

    def count(self):
        return len(self.__students)

    def search(self, s):
        if s.get_n_insee() in self.__students:
            return True
        return False


class Student:
    def __init__(self, surname, given_name, student_id, n_insee, photo=None):
        self._surname = surname
        self._given_name = given_name
        self._student_id = student_id
        self._n_insee = n_insee  # Type is 'N_INSEE'
        # Etc.

    def get_n_insee(self):
        return self._n_insee


fb1 = Student('Barbier', 'Franck', '?', N_INSEE('1630125388055', 29))
fb2 = Student('Barbier', 'Franck', '?', N_INSEE('1630125388055', 29))
u = University(fb1, fb2)
print(u.count())  # '2' is displayed when '__eq__(self, n_insee)' '__hash__(self)' are *NOT* overridden!
